<template>
  <q-page padding>
    <div class="column fullwidth q-pa-sm">
      <q-calendar
        ref="calendar"
        v-model="date"
        view="month"
        locale="en-us"
        mini-mode="auto"
        breakpoint="xs"
        enable-theme
        :theme="$q.dark.isActive ? dark : {}"
        v-touch-swipe.mouse.left.right="handleSwipe"
        animated
        :short-weekday-label="true"
        transition-prev="jump-right"
        transition-next="jump-left"
        @click:day="handleDayClick"
        @click:date="handleDayClick"
        style="cursor: pointer;"
        class="col-6"
      >
        <template #day="{ date }">
          <div v-if="days[date]">
            <q-badge
              color="yellow"
              text-color="grey-1"
              style="width: 90%; cursor: pointer;margin-bottom: 8px;"
              class="q-event"
              v-for="event in days[date]"
              :key="event.id"
            >
            </q-badge>
          </div>
        </template>
      </q-calendar>
      <event-list class="col" :selected="selected"></event-list>
    </div>

    <q-dialog maximized transition="expand" v-model="editing">
      <q-card fullheight>
        <q-toolbar class="bg-primary text-secondary" reveal="true">
          <q-btn
            flat
            round
            icon="arrow_back"
            color="grey-1"
            @click="handleCloseEditor"
          ></q-btn>
          <q-toolbar-title class="grey-1-header">
            {{ noteTitle }}
          </q-toolbar-title>
        </q-toolbar>

        <q-card-section>
          <q-input
            type="text"
            placeholder="Add some notes to this day..."
            borderless
            v-model="note"
            autofocus
            autogrow
          ></q-input>
        </q-card-section>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
import { mapActions, mapState } from "vuex";
import EventList from "components/EventList";

export default {
  name: "PageIndex",
  components: {
    EventList
  },
  data() {
    return {
      showOverlay: true,
      editing: false,
      empty: "",
      note: "",
      noteTitle: "",
      date: "",
      editorReadOnly: false,
      dragging: false,
      ignoreNextSwipe: false,
      currentCalDisplay: "",
      currentMonth: "",
      selected: "",
      dark: {
        name: "dark",
        // body
        colorBody: "grey-2",
        backgroundBody: "blue-grey-8",
        colorBodyOutside: "grey-6",
        backgroundBodyOutside: "blue-grey-9",
        colorBodyPast: "grey-11",
        backgroundBodyPast: "blue-grey-10",
        colorBodyCurrent: "blue-grey-2",
        backgroundBodyCurrent: "blue-grey-10",
        colorBodyFuture: "blue-grey-2",
        backgroundBodyFuture: "blue-grey-10",
        // header - weekly only
        colorHeader: "blue-grey-2",
        backgroundHeader: "blue-grey-10",
        colorHeaderOutside: "blue-grey-2",
        backgroundHeaderOutside: "blue-grey-10",
        // header - for daily only
        colorHeaderPast: "grey-11",
        backgroundHeaderPast: "blue-grey-10",
        colorHeaderCurrent: "blue-grey-2",
        backgroundHeaderCurrent: "blue-grey-10",
        colorHeaderFuture: "blue-grey-2",
        backgroundHeaderFuture: "blue-grey-10",
        // work week - monthly only
        colorWorkWeekPast: "blue-grey-8",
        backgroundWorkWeekPast: "blue-grey-6",
        colorWorkWeekCurrent: "orange-4",
        backgroundWorkWeekCurrent: "blue-grey-10",
        colorWorkWeekFuture: "yellow-4",
        backgroundWorkWeekFuture: "blue-grey-10",
        // label
        colorDayLabelOutside: "blue-grey-2",
        backgroundDayLabelOutside: "blue-grey-9",
        colorDayLabelPast: "yellow-4",
        backgroundDayLabelPast: "blue-grey-10",
        colorDayLabelCurrent: "orange-4",
        backgroundDayLabelCurrent: "blue-grey-10",
        colorDayLabelFuture: "yellow-4",
        backgroundDayLabelFuture: "blue-grey-10",
        // interval body
        colorIntervalHeader: "grey-2",
        backgroundIntervalHeader: "blue-grey-10",
        colorIntervalBody: "grey-2",
        backgroundIntervalBody: "blue-grey-10",
        colorIntervalText: "grey-2",
        backgroundIntervalText: "blue-grey-10",
        // scheduler body
        colorSchedulerHeader: "grey-2",
        backgroundSchedulerHeader: "blue-grey-10",
        colorSchedulerBody: "grey-2",
        backgroundSchedulerBody: "blue-grey-10",
        colorSchedulerText: "grey-2",
        backgroundSchedulerText: "blue-grey-10"
      }
    };
  },
  created() {
    this.$root.$on("navigate", this.handleNavigate);
  },
  beforeDestroy() {
    this.$root.$off("navigate", this.handleNavigate);
  },
  beforeMount() {
    const now = new Date();
    this.date =
      now.getFullYear() +
      "-" +
      this.padNumber(now.getMonth() + 1, 2) +
      "-" +
      this.padNumber(now.getDay(), 2);
  },
  computed: {
    ...mapState(["notes", "user", "days"])
  },
  methods: {
    ...mapActions([
      "addDay",
      "updateDay",
      "deleteDay",
      "setUser",
      "setNotes",
      "loadBlockstackData",
      "initBlockstack"
    ]),

    async handleNavigate(direction) {
      if (direction === "prev") {
        await this.$refs.calendar.prev();
        this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
      } else if (direction === "next") {
        await this.$refs.calendar.next();
        this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
      } else {
        this.date = new Date().toISOString().slice(0, 10);
        this.$nextTick(() => {
          this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
        });
      }
    },
    async calendarNext() {
      await this.$refs.calendar.next();
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    async calendarPrev() {
      await this.$refs.calendar.prev();
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    dayDisplay(selectedDate) {
      const words = this.notes[selectedDate]
        .split(/\s+/)
        .slice(0, 13)
        .join(" ");
      return words;
    },
    handleSwipe({ evt, ...info }) {
      if (this.dragging === false) {
        if (info.duration >= 30 && this.ignoreNextSwipe === false) {
          if (info.direction === "right") {
            this.calendarPrev();
          } else if (info.direction === "left") {
            this.calendarNext();
          }
        } else {
          this.ignoreNextSwipe = false;
        }
      }
      // stopAndPrevent(evt)
      evt.cancelable !== false && evt.preventDefault();
      evt.stopPropagation();
    },
    handleDayClick(e) {
      console.log("day clicked: ", e);
      this.date = e.date;
      // scroll event list to selected day
      this.selected = e.date;

    },
    async handleCloseEditor() {
      if (this.note.length) {
        await this.addDay({ id: this.date, note: this.note });
      }
      this.editing = false;
      this.noteTitle = "";
      this.note = "";
      this.editorReadOnly = false;
      await this.$refs.calendar.date;
      this.$root.$emit("updateMonthDisplay", this.$refs.calendar.value);
    },
    padNumber(num, length) {
      let padded = String(num);
      while (padded.length < length) {
        padded = "0" + padded;
      }
      return padded;
    }
  },
  beforeRouteLeave(to, from, next) {
    // called when the route that renders this component is about to
    // be navigated away from.
    // has access to `this` component instance.
    if (this.editing) {
      this.editing = false;
      next(false);
    } else {
      next();
    }
  }
};
</script>
<style scoped></style>
